# Lessons Learned Designing and Evaluating CLAICA: continously learning AI cognitive assistant
Authors: S. Kernan Freire, E. Niforatos, S. Ruiz Arenas, M. Foosherian, S. Wellsandt, A. Bozzon.
Knowledge and Intelligence Design Group, Faculty of Industrial Design Engineering, Delft 
University of Technology
Corresponding author: S. Kernan Freire 
Contact Information:
skernanfreire@gmail.com

## General Introduction
This dataset contains data collected from factory personnel during prototype evaluations 
from August and September 2022 as part of Samuel Kernan Freire's PhD Thesis project.
It is being made public both to act as supplementary data for publications and the PhD 
thesis of Samuel Kernan Freire and in order for other researchers to use this data in their own 
work.

This work was supported by the European Union’s Horizon 2020
research and innovation program via the project COALA “COgnitive Assisted agile manufacturing 
for a LAbor force supported by trustworthy Artificial Intelligence” (Grant agreement 957296)

## Purpose of the study campaign
The purpose of this study was to explore several factors affecting the user experience and usability of
continously learning cognitive assistants for factory operators.

## Method
The data was through a survey after testing a prototype. The data was processed to removed personally identifable or confidential information.
Furthermore, the UEQ and SUS scores were calculated using the standard formulas.

## Description of the data in this data set
The data has the following the nomenclature:
device: laptop or smartphone
pool: different study sessions
Task 1 - 8: the different tasks participants were assigned
Timing data: how long the participants spent on the tasks
NASA-TLX columns (mental, ... frustration and average)(columns Q-W)
SUS columns (system usability scale)(columns X-AH)
RAW UEQ (user experience questionnaire) (columns AI-BH)
Processed UEQ: using offical excel sheet (columns BI-BN)
Personal factors: columns BO-BV