# Operator Perceptions of the Impact, Risk and Challenges of Cognitive Assistants for Knowledge Sharing
Authors: S. Kernan Freire, T. He, C. Wang, E. Niforatos, A. Bozzon.
Knowledge and Intelligence Design Group, Faculty of Industrial Design Engineering, Delft 
University of Technology
Corresponding author: S. Kernan Freire 
Contact Information:
skernanfreire@gmail.com

## General Introduction
This dataset contains data collected from factory personnel during prototype evaluations 
from April 2021 to September 2023 as part of Samuel Kernan Freire's PhD Thesis project.
It is being made public both to act as supplementary data for publications and the PhD 
thesis of Samuel Kernan Freire and in order for other researchers to use this data in their own 
work.

This work was supported by the European Union’s Horizon 2020
research and innovation program via the project COALA “COgnitive Assisted agile manufacturing 
for a LAbor force supported by trustworthy Artificial Intelligence” (Grant agreement 957296)

## Purpose of the study campaign
The purpose of this longitudinal study was to investigate the perspectives of factory personnel,
especially the factory operators and their managers on using cognitive assistants to support
knowledge sharing in factories. 

## Method
The data was collected through semi-structured interviews, observations, and surveys during or after
testing prototypes. The data was processed to removed personally identifable or confidential information.
Furthermore, some of the comments were split up such that each datapoint contained a single statement.

## Description of the data in this data set
The data included in this data set has been organised per comment with an additional file for the 
participant information.

### Comments
The comment file has the following the nomenclature:
id
date
phase: matches phase in participants list
location: factory 1 or 2
Participant id: matches participants list
Content


### Participants
Participant id
Role: (operator, manager or technician)
Factory: (1 or 2)
Phase (prototyping fase: 1 = technical probe, 2=chatbot with simulated environment,3=voice assistant 
with chat, live data and llm integration, 4 = pure LLM)
Test duration (minutes)
Prior Experience: if they participated in previous phases
Gender: Male or Female

## Code
This data is accompanied by code (in folder factory_assistant) for the prototype from phase 3. Code from other phases is not available due to confidentiality agreements with the factories and spin-off.

The code is built on the Mycroft android project (https://github.com/MycroftAI/Mycroft-Android) and legacy Rasa X (https://legacy-docs-rasa-x.rasa.com/docs/rasa-x/).

Additional collaborators for the code: M. Foosherian and S. Wellsandt from BIBA.