# coala-lab-demo / cognitive advisor

This lab demo is a result of the H2020 DIA COALA. It focuses on a cognitive advisor for manufacturing.
Languages: EN, NL, IT.

* Domain split into several files for easier handling.
* Training data split into several files for easier handling.
* ci file split into several files for easier handling.

We need to keep nlu.yml rules.yml stories.yml domain.yml in the standard paths to store new interactive training results properly. After interactive training, you may need to move results to the right file manually.

Since the project has a custom directory structure for training data and domain files, you need to execute Rasa commands with specific parameters (see below).

## Console commands

These are useful console commands, typically for local tests.

### Validate local training data

``` Python
# Sometimes needed to validate training data and domain
rasa data validate --domain domain --data data --verbose --debug --max-history 5
```

### Train local model using

``` Python
# Always needed for local testing
rasa train --domain domain --data data
```

### Run local rasa instance

``` Python
# Run a Rasa server locally (mostly not needed)
rasa run

# Run a Rasa shell interface locally (to interact with bot via terminal)
rasa shell --debug

# Run the action server locally (always needed for local testing)
rasa run actions --debug
```

### Run local test cases

``` Python
rasa test
```

## Action server configs

The action server connects to several internal and external endpoints. Internal ones include GraphQL, Rasa X, GitLab, and various databases. The "configs" folder stores the configuration for these endpoints in three files:

* action_server_config.yaml
* credentials.yaml
* endpoints.yaml

Each file uses the YAML format. Credentials.yaml contains passwords and tokens, and endpoints.yaml the URLs, ports, etc. The action_server_config.yaml stores information about, e.g. the language used in the action server. It is important for the localization function, for instance.

Every server aor local deployment of this Rasa chatbot must prepare these configuration files. Mount these files to the action-server container if you use Docker on a server.

## Sentences to try in shell

``` Text
Ik wil product instelling opslaan

ik heb hulp nodig bij een storing

ik wil een storing melden

wat is de vulmachine?
```

## Feature outline

### Retrieving and saving product settings

### Retrieving and saving issue descriptions and solutions

### Retrieving task instructions

### Answering FAQs

### (In progress) Recommending production speed adjustments (using an RF model)


### (In progress) Providing an explanation for speed adjustments

### Localization in actions

Go to the base directory of this bot and perform the following commands. If you have several languages, make sure you have one msgmerge line with the right path to the po file for each.
The folder will contain a backup file indicated by a ~ symbol in the filename.

``` Bash
pygettext3 -p actions/locales -o base.pot actions
msgmerge --update actions/locales/en/LC_MESSAGES/base.po actions/locales/base.pot
msgmerge --update actions/locales/it/LC_MESSAGES/base.po actions/locales/base.pot
msgmerge --update actions/locales/nl/LC_MESSAGES/base.po actions/locales/base.pot
```

Make sure that you have one msgfmt line per language too.
Execute these commands after adding the translated strings to build the .mo files out of the .po files.

``` Bash
msgfmt -o actions/locales/en/LC_MESSAGES/base.mo actions/locales/en/LC_MESSAGES/base
msgfmt -o actions/locales/it/LC_MESSAGES/base.mo actions/locales/it/LC_MESSAGES/base
msgfmt -o actions/locales/nl/LC_MESSAGES/base.mo actions/locales/nl/LC_MESSAGES/base
```
