from typing import Dict, Text, List, Optional, Any

from rasa_sdk import Action, Tracker
from rasa_sdk.executor import CollectingDispatcher
from rasa_sdk.events import SlotSet, EventType
from rasa_sdk.types import DomainDict
from rasa_sdk.forms import FormValidationAction
# from rasa_sdk.forms import FormValidationAction

from actions.helpers.lab_sim_query import (
   get_status
   )

import requests
import json

# Needed to interact with graphql database
from actions.graphql_interfaces.graphql_queries import (
    graphql_findsolution
    )

# Needed to import synonym helper function
from actions.helpers.synonym_manager import (
   find_synonym_for_agnostic_entity
   )

from actions.helpers.UBI_token_manager import (
    TokenManager
)

from actions.helpers.zed2_query_DIV_ENS import (
    zed2_data_limit_query
)

import actions.helpers.graphql_helpers as helpers

# Needed to interact with graphql database
# from actions.graphql_interfaces.graphql_queries import (
#    graphql_get_product_profile_active_checklist_step,
#    graphql_update_product_profile
#    )

import logging
logger = logging.getLogger(__name__)

tm = TokenManager()

# class AskForSlotActionProductNumber(Action):
#     def name(self) -> Text:
#         return "action_ask_product_number"

#     def run(
#         self, dispatcher: CollectingDispatcher, tracker: Tracker, domain: Dict
#     ) -> List[EventType]:
#         message = "Wat is de huidige SKU nummer?"
#         # product_number = tracker.get_slot('product_number')

#         # status_response = get_status()
#         # product_number = status_response["product_number"]

#         # if product_number:
#         #     payload = "/inform{\"number\":\"" + product_number + "\"}"
#         #     button= [{"title": f'{product_number} 🤖', "payload": payload}]
#         # else:
#         #     button=None
#         # dispatcher.utter_message(text=message,buttons=button)
#         dispatcher.utter_message(text=message)
#         return []
    
class AskForSlotActionRequireNewSolution(Action):
    def name(self) -> Text:
        return "action_ask_report_solution_description"

    def run(
        self, dispatcher: CollectingDispatcher, tracker: Tracker, domain: Dict
    ) -> List[EventType]:
        
        machine_component_long = tracker.get_slot('machine_component')
        machine_component = machine_component_long.replace('MC','')
        descEn = tracker.get_slot('report_symptom_description')
        if descEn == None:
            descEn=""
        error_code = tracker.get_slot('error_code')

        try:
            """
            solution_info = graphql_findsolution(descEn,error_code,machine_component)
            response = helpers.get_solution(solution_info)
            # hits = len(solution)
            # if hits >= 1:
            dispatcher.utter_message(response="utter_solutions_found")

            # sort response by speed, rating and recency
            sorted_response = sorted(response, key=lambda i: (i['rate']))

            for hits in sorted_response:
                descEn2 = hits["descEn2"]
                rate = rate["rate"]
                status = status["status"]
                # descNl2 = hits["descNl2"]
                text = f'{descEn2}. Rating is {rate}'
                rate = hits["rate"]
                status = hits["status"]
                # descNl2 = hits["descNl2"]
                text = f'{descEn2}. Rating {rate}'
                dispatcher.utter_message(text)
            """
        except:
            dispatcher.utter_message(response="utter_no_solutions_found")

        dispatcher.utter_message(response = "utter_ask_report_solution_description")
        return []

class AskForSlotActionErrorCode(Action):
    def name(self) -> Text:
        return "action_ask_error_code"

    def run(
        self, dispatcher: CollectingDispatcher, tracker: Tracker, domain: Dict
    ) -> List[EventType]:
        question = "Is er een foutcode? Zo ja, geef die dan alstublieft."

        buttons = []
        
        buttons.append({"title": "Nee, geen foutcode", "payload":'/inform{"number":"0"}'})

        dispatcher.utter_message(text=question,buttons=buttons)
        return []

class setErrorMessage(Action):
    def name(self) -> Text:
        return "action_set_error_code"

    def run(
        self, dispatcher: CollectingDispatcher, tracker: Tracker, domain: Dict
    ) -> List[EventType]:

        return [SlotSet("error_code","0")]

class AskForSlotActionMachineComponent(Action):
    def name(self) -> Text:
        return "action_ask_machine_component"

    def run(
        self, dispatcher: CollectingDispatcher, tracker: Tracker, domain: Dict
    ) -> List[EventType]:
        assets = {
            "Checkweger": "MC10013",
            "Vuller": "MC10600",
            "Etiketeer machine": "MC5038",
            "Doppendraaier": "MC10601",
            "Sleever": "MC10815",
            "Palletizer": "MC10823",
            }
        message = "Wat is de machinecomponent?"

        # # get bearer token
        # bearer_token = tm.get_bearer_token()

        # # query camera data with a limit and bearer token
        # limit = 60
        # zed2_data_limit_query(limit,bearer_token)

        # todo: code to extract user location OR use raw coordinates to determine location
        
        
        try:
            # commented zed2 interface code for zed2 at TUD
            # result = zed2Interface().query_user_location()
            # user_activity = result[0][0]

            # temporarily set activity to None until integration with zed2 at DIV ENS is ready
            user_activity = None

            logger.info(f"this is the user activity {user_activity}")
            payload = "/inform{\"machine_component\":\"" + assets[user_activity] + "\"}"
            title = f'{user_activity} 📷'
            button= [{"title": title, "payload": payload}]
            dispatcher.utter_message(text=message,buttons=button)
        except:
            button=[]
            logger.info("Something went wrong getting user location or building the button")
            payload1 = "/inform{\"machine_component\":\"" + assets["Checkweger"] + "\"}"
            payload2 = "/inform{\"machine_component\":\"" + assets["Vuller"] + "\"}"
            payload3 = "/inform{\"machine_component\":\"" + assets["Etiketeer machine"] + "\"}"
            payload4 = "/inform{\"machine_component\":\"" + assets["Doppendraaier"] + "\"}"
            payload5 = "/inform{\"machine_component\":\"" + assets["Sleever"] + "\"}"
            payload6 = "/inform{\"machine_component\":\"" + assets["Palletizer"] + "\"}"
            button.append({"title": "Checkweger", "payload": payload1})
            button.append({"title": "Vuller", "payload": payload2})
            button.append({"title": "Etiketeer machine", "payload": payload3})
            button.append({"title": "Doppendraaier", "payload": payload4})
            button.append({"title": "Sleever", "payload": payload5})
            button.append({"title": "Palletizer", "payload": payload6})
            dispatcher.utter_message(text=message,buttons=button)

        
        return []