from typing import Text, List
import random
from rasa_sdk import Action, Tracker
from rasa_sdk.executor import CollectingDispatcher
from rasa_sdk.events import SlotSet, EventType
from rasa_sdk.types import DomainDict
from datetime import datetime
from dateutil import tz
# from rasa_sdk.forms import FormValidationAction

# Needed to import synonym helper function
# from actions.helpers.synonym_manager import (
#    find_synonym_for_agnostic_entity
#    )
# Needed to interact with graphql database
from actions.graphql_interfaces.graphql_queries import (
    graphql_createSkuStat
    )

# Needed to import graphql helper functions
import actions.helpers.graphql_helpers as helpers

import logging
logger = logging.getLogger(__name__)


class actionChangeStatusFillerSettings(Action):
    """
        once the form is filled, the bot utters
        updates the node status
    """

    def name(self) -> Text:
        return "action_change_status_settings"

    def run(
            self,
            dispatcher: CollectingDispatcher,
            tracker: Tracker,
            domain: DomainDict,
    ) -> List[EventType]:

        node_status = tracker.get_slot("node_status")
        datetime = tracker.get_slot("latest_settings_recommendation_datetime")

        graphql_createSkuStat(datetime, node_status)

        dispatcher.utter_message(response="utter_thanks")

        return [SlotSet("node_status", None)]
