from typing import Any, Text, Dict, List
from rasa_sdk import Action, Tracker
from rasa_sdk.events import SlotSet, EventType
from rasa_sdk.executor import CollectingDispatcher


from actions.helpers.openai_API import (
   OpenAI
   )

class HandleOOSIntent(Action):
    def name(self) -> Text:
        return "action_handle_oos_intent"

    def run(self, dispatcher: CollectingDispatcher,
            tracker: Tracker,
            domain: Dict[Text, Any]) -> List[EventType]:
        
        # Get the user input from the tracker
        user_input = tracker.latest_message.get('text')
        
        # Set a slot to track the user's answer
        return [SlotSet("oos_response", user_input)]

class GetOOSResponse(Action):
    def name(self) -> Text:
        return "action_get_oos_response"

    def run(self, dispatcher: CollectingDispatcher,
            tracker: Tracker,
            domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
        
        # Get the user's answer from the slot
        oos_response = tracker.get_slot("oos_response")
        
        # todo clean up 
        
        # Check if the user wants an answer from OpenAI
        affirm_intent_detected = False
        for event in reversed(tracker.events):
            if event.get("event") == "user" and event.get("parse_data"):
                intent = event.get("parse_data").get("intent").get("name")
                if intent == "affirm":
                    affirm_intent_detected = True
                    break
        
        if affirm_intent_detected and (oos_response is not None):
            
            # # Generate a response from OpenAI
            # prompt = oos_response


            # response = generate_text(prompt,"davinci")

            # # Send the response back to the user
            dispatcher.utter_message("Sorry, dat weet ik niet")
        
        return [SlotSet("oos_response", None)]

