from typing import Text, List
import random
from rasa_sdk import Action, Tracker
from rasa_sdk.executor import CollectingDispatcher
from rasa_sdk.events import SlotSet, EventType
from rasa_sdk.types import DomainDict
from datetime import datetime
from dateutil import tz
# from rasa_sdk.forms import FormValidationAction

# Needed to import synonym helper function
# from actions.helpers.synonym_manager import (
#    find_synonym_for_agnostic_entity
#    )
# Needed to interact with graphql database
from actions.graphql_interfaces.graphql_queries import (
    graphql_searchset,
    graphql_createSkuRate,
    graphql_createSkuStat
    )

# Needed to import graphql helper functions
import actions.helpers.graphql_helpers as helpers

import logging
logger = logging.getLogger(__name__)


class actionRateFillerSettings(Action):
    """
        once the form is filled, the bot utters
        the requested information
    """

    def name(self) -> Text:
        return "action_rate_filler_settings"

    def run(
            self,
            dispatcher: CollectingDispatcher,
            tracker: Tracker,
            domain: DomainDict,
    ) -> List[EventType]:

        rating = tracker.get_slot("rating")
        datetime = tracker.get_slot("latest_settings_recommendation_datetime")
        rating_float = float(rating)
        
        if rating_float < 2.0:
            graphql_createSkuRate(datetime,rating_float)
            graphql_createSkuStat(datetime,"pending review")            
            dispatcher.utter_message(response="utter_rating_registered_and_flagged")
            dispatcher.utter_message(response="utter_if_user_has_new_settings")
        else:
            graphql_createSkuRate(datetime,rating_float)
            dispatcher.utter_message(response="utter_rating_registered")
        return [SlotSet("rating", None)]
