from typing import Any, Text, Dict, List

from rasa_sdk import Action, Tracker
from rasa_sdk.executor import CollectingDispatcher
from rasa_sdk.events import SlotSet, EventType
from rasa_sdk.types import DomainDict

from actions.helpers.WhyEngineClient import (
   WhyEngineClient
   )

class UploadWhyEngineModel(Action):
    """
       upload why engine model
    """
    def name(self) -> Text:
        return "action_upload_why_engine_model"

    def run(
        self,
        dispatcher: CollectingDispatcher,
        tracker: Tracker,
        domain: DomainDict
    ) -> List[EventType]:
        '''
            Uses the tracker to get the required slots
        '''

        client = WhyEngineClient()

        try:
            client.upload_model()

            # send message to user
            dispatcher.utter_message(response="utter_okay")
        except:
            dispatcher.utter_message(
                        response="connection_error",
                        service_name="why engine"
                    )
        
        return []