from typing import Any, Text, Dict, List
import requests
import time
import logging
log = logging.getLogger("requesting bearer token")
import actions.helpers.config_loader as config


class TokenManager:
    def __init__(self):
        self.bearer_token = None
        self.token_time = None
        self.user = config.get_credentials("graphql_token").get("user", "")
        self.password = config.get_credentials("graphql_token").get("password", "")
        self.client_id = config.get_endpoint("graphql_token").get("client_id", "")
        self.url = config.get_endpoint("graphql_token").get("url", "")
    
    # todo: remove personal logins from code
    def get_bearer_token(self):
        # Check if the token is not yet obtained or if it has expired (>4 minutes minus 5 seconds buffer)
        if self.bearer_token is None or time.time() - self.token_time > 235:
            url = self.url
            headers = {'Content-Type': 'application/x-www-form-urlencoded'}
            data = {'grant_type': 'password', 'client_id': self.client_id, 'username': self.user, 'password': self.password}

            response = requests.post(url, headers=headers, data=data, timeout=2)
            data = response.json()
            access_token = data['access_token']
            self.bearer_token = "Bearer " + access_token
            self.token_time = time.time()  # Store the time when the token was obtained
        
        return self.bearer_token