import base64
import json
import pickle
import requests
from requests.structures import CaseInsensitiveDict

import actions.helpers.config_loader as config

import plotly.graph_objs as go
import plotly.io as pio
from imgurpython import ImgurClient

class GraphPlotter:
    def __init__(self, imgur_client_id, imgur_client_secret):
        self.imgur_client_id = config.get_credentials("imgur").get("client_id", "")
        self.imgur_client_secret = config.get_credentials("imgur").get("client_secret", "")
        self.client = ImgurClient(imgur_client_id, imgur_client_secret)
        
    def create_timeseries_plot(self, x, y):
        fig = go.Figure()
        fig.add_trace(go.Scatter(x=x, y=y))
        fig.update_layout(title='Time Series Plot')
        pio.write_image(fig, 'plot.jpeg')
        
    def upload_to_imgur(self):
        image = self.client.upload_from_path('plot.jpeg')
        return image['link']

    



