from typing import Text

# Needed to parse synonyms and other custom yaml files.
import yaml

import logging
log = logging.getLogger("Debugging")


# ! Need to discuss this
class SynonymManager():
    '''
        This class manages synonyms.
    '''

    def __init__(self, synonym_file_path: Text):
        pass

    def find(entity_value: Text):
        pass


def find_synonym_for_agnostic_entity(entity_value: Text) -> Text:

    '''
        This function manages language agnostic entity values.
        It gets the first matching synonym from the synonyms.yml
        file in the actions folder. It returns None if there is no
        synonym for the entity.
    '''

    import re  # for advanced string operations
    with open('data/nlu/cognitive_advisor/gen_nlu_lookup_machine_component_en_synonyms.yml') as file:
        # The FullLoader parameter handles the conversion from YAML
        # scalar values to Python the dictionary format

        synonyms_dic = yaml.load(file, Loader=yaml.SafeLoader)
        synonyms_list = synonyms_dic["nlu"]

        response = next(
            (sub for sub in synonyms_list if sub['synonym'] == entity_value),
            None
        )

        if response is not None:
            synonym_examples = response["examples"]
        else:
            synonym_examples = None

    if synonym_examples is not None:

        # clean string from annotations
        # for example: [- synonym one \n- synonym two]
        # https://stackabuse.com/using-regex-for-text-manipulation-in-python/
        # https://regexr.com/
        annotation_pattern = "\n"
        # synonym example string without annotations:
        cleaned_string = re.sub(annotation_pattern, "", synonym_examples)

        # split strings into a list when there is a -
        synonym_example_list = cleaned_string.split("- ")
        # Remove spaces at the beginning and at the end of the string
        clean_list_of_synonyms = list(filter(
            lambda item: item.strip(), synonym_example_list
            ))
        # always match the entity with the very first synonym
        synonym_for_entity = clean_list_of_synonyms[0]

    else:
        # there is no synonym for the entity, use the original entity value
        synonym_for_entity = entity_value

    return {"synonym_for_entity": synonym_for_entity}
