# Here we collect all helpers that get useful information
# from the conversation Tracker.

from rasa_sdk import Tracker
from typing import Text


# TODO Need to check the comments especially the comment about nlu_fallback
def get_latest_intent_name(tracker: Tracker) -> Text:
    '''
        This function gets the intent's name of the last user message.
    '''
    user_event_list = []

    for events in tracker.events_after_latest_restart():
        if events["event"] == "user":
            user_event_list.append(events)

    # get the ranking of the last user message
    last_intent_ranking = user_event_list[-1].get(
        "parse_data", []).get("intent_ranking", [])

    # Delete dictionary with key "nlu_fallback" from the intent
    # ranking list.
    last_intent_ranking_clean = [i for i in last_intent_ranking if not
                                 (i['name'] == 'nlu_fallback')]

    # Get the name of the matched intent for last user message.
    # The first one in Rasa 2.x is always nlu_fallback.
    return last_intent_ranking_clean[0].get("name")


def get_latest_user_message(tracker: Tracker) -> Text:
    '''
        This function gets the text from the last user message.
    '''

    user_event_list = []

    for events in tracker.events_after_latest_restart():
        if events["event"] == "user":
            user_event_list.append(events)

    return user_event_list[-1].get("text")
