
import logging
log = logging.getLogger("query zed2 data")

import requests

from actions.helpers.UBI_token_manager import (
   TokenManager
   )

import actions.helpers.config_loader as config

def zed2_data_limit_query(limit):

    url = config.get_endpoint("graphql_query").get("url", "")
    
    token_manager = TokenManager()
    bearer_token = token_manager.get_bearer_token()

    query = """
        query ListDatawithLimit($limit: Int!) {
          listDatawithLimit(limit: $limit) {
            id
            timestamp
            _id
            random_id
            time_epoch
            x_axis
            y_axis
            z_axis
            distance_from_camera
            velocity
          }
        }
    """

    headers = {
        "Content-Type": "application/json",
        "Authorization": bearer_token
    }

    data = {
        "query": query,
        "variables": {
            "limit": limit
        }
    }

    response = requests.post(url, headers=headers, json=data)

    if response.status_code == 200:
        return response.json()
    else:
        raise Exception("Query failed to run by returning code of {}. {}".format(response.status_code, query))

